Blame gmon/tst-gmon-gprof.sh

Packit 6c4009
#!/bin/sh
Packit 6c4009
# Check the output of gprof against a carfully crafted binary.
Packit 6c4009
# Copyright (C) 2017-2018 Free Software Foundation, Inc.
Packit 6c4009
# This file is part of the GNU C Library.
Packit 6c4009
Packit 6c4009
# The GNU C Library is free software; you can redistribute it and/or
Packit 6c4009
# modify it under the terms of the GNU Lesser General Public
Packit 6c4009
# License as published by the Free Software Foundation; either
Packit 6c4009
# version 2.1 of the License, or (at your option) any later version.
Packit 6c4009
Packit 6c4009
# The GNU C Library is distributed in the hope that it will be useful,
Packit 6c4009
# but WITHOUT ANY WARRANTY; without even the implied warranty of
Packit 6c4009
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Packit 6c4009
# Lesser General Public License for more details.
Packit 6c4009
Packit 6c4009
# You should have received a copy of the GNU Lesser General Public
Packit 6c4009
# License along with the GNU C Library; if not, see
Packit 6c4009
# <http://www.gnu.org/licenses/>.
Packit 6c4009
Packit 6c4009
LC_ALL=C
Packit 6c4009
export LC_ALL
Packit 6c4009
set -e
Packit 6c4009
exec 2>&1
Packit 6c4009
Packit 6c4009
GPROF="$1"
Packit 6c4009
program="$2"
Packit 6c4009
data="$3"
Packit 6c4009
Packit 6c4009
actual=$(mktemp)
Packit 6c4009
expected=$(mktemp)
Packit 6c4009
expected_dot=$(mktemp)
Packit 6c4009
cleanup () {
Packit 6c4009
    rm -f "$actual"
Packit 6c4009
    rm -f "$expected"
Packit 6c4009
    rm -f "$expected_dot"
Packit 6c4009
}
Packit 6c4009
trap cleanup 0
Packit 6c4009
Packit 6c4009
cat > "$expected" <
Packit 6c4009
f1 2000
Packit 6c4009
f2 1000
Packit 6c4009
EOF
Packit 6c4009
Packit 6c4009
# Special version for powerpc with function descriptors.
Packit 6c4009
cat > "$expected_dot" <
Packit 6c4009
.f1 2000
Packit 6c4009
.f2 1000
Packit 6c4009
EOF
Packit 6c4009
Packit 6c4009
"$GPROF" -C "$program" "$data" \
Packit 6c4009
    | awk -F  '[(): ]' '/executions/{print $5, $8}' \
Packit 6c4009
    | sort > "$actual"
Packit 6c4009
Packit 6c4009
if cmp -s "$actual" "$expected_dot" \
Packit 6c4009
   || diff -u --label expected "$expected" --label actual "$actual" ; then
Packit 6c4009
    echo "PASS"
Packit 6c4009
else
Packit 6c4009
    echo "FAIL"
Packit 6c4009
    exit 1
Packit 6c4009
fi